Subject: Extract displayCond functionality from FormEngine to new class

Description

I'd like to extend the 'displayCond' mechanism by a new type, but \TYPO3\CMS\Backend\Form\FormEngine (formerly
t3lib_TCEforms) is way to bloated anyway. So | thought this might be a good point to streamline FormEngine a bit and extract the
displayCond functionality to a new class: \TYPO3\CMS\Backend\Form\ElementConditionMatcher

I (hope I) didn't change any functionality, | just tried to split thing a up into clean pieces.

Related issues:

related to Core - Bug # 49354: Call to undefined method TYPO3\CMS\Backend\For... Resolved 2013-06-23
related to Core - Bug # 47988: Colon not possible in TCA "displayCond" value Resolved 2013-05-06
blocks Core - Feature # 46460: Introduce TCA displayCond type "USER" Resolved 2013-03-20

Associated revisions

Revision cf170670 - 2013-03-31 13:34 - Sebastian Michaelsen

[TASK] Extract displayCond functionality from FormEngine to new class

In order to streamline \TYPO3\CMS\Backend\Form\FormEngine
(formerly t3lib_TCEforms) the functionality for 'displayCond' is extracted
into a new class: \TYPO3\CMS\Backend\Form\ElementConditionMatcher

- Refactor the code a bit without changing it's behaviour

- Deprecate FormEngine->isDisplayCondition() and remove its core usages
- Add a bit of documentation in the new class

- Add Unit tests

Releases: 6.1

Resolves: #46461

Change-Id: le199fe0600a70231f1e7b710a09164364cef8578
Reviewed-on: https://review.typo3.org/19080

Reviewed-by: Anja Leichsenring
Tested-by: Anja Leichsenring
Reviewed-by: Christian Kuhn
Tested-by: Christian Kuhn

History

#1 - 2013-03-20 14:34 - Gerrit Code Review
- Status changed from New to Under Review
https://review.typo3.org/19080

Patch set 3 for branch master has been pushed to the review server.

It is available at https://review.typo3.org/19080

#2 - 2013-03-20 14:37 - Sebastian Michaelsen

Accidently flagged this issue as "BUG", but it should rather be a "TASK"

#3 - 2013-03-20 15:01 - Stefan Galinski

- Tracker changed from Bug to Task

#4 - 2013-03-21 13:01 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19080

#5 - 2013-03-25 14:15 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19080

#6 - 2013-03-26 21:42 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/19080

#7 - 2013-03-31 12:41 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19080

#8 - 2013-03-31 12:55 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19080

#9 - 2013-03-31 13:00 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/19080

#10 - 2013-03-31 13:08 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/19080
#11 - 2013-03-31 14:30 - Sebastian Michaelsen
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:cf1706708d43781bef47e6d0f9c15521caecdaec.

#12 - 2013-05-29 16:19 - David Greiner

Hey!

| got a fatal error by creating new media element (via page module).

Call to undefined method TYPO3\CMS\Backend\Form\ElementConditionMatcher::setRecord() in
xxx/typo3_src-6.1.1/typo3/sysext/backend/Classes/Form/FormEngine.php on line 5954

5950 public function isDisplayCondition($displayCond, $row, $ffValueKey = ") {

5951 \TYPO3\CMS\Core\Utility\GeneralUtility::logDeprecatedFunction();

5952 /** @var $elementConditionMatcher \TYPO3\CMS\Backend\Form\ElementConditionMatcher */

5953 $elementConditionMatcher =
\TYPO3\CMS\Core\Utility\GeneralUtility::makelnstance('TYPO3\CMS\\Backend\\Form\\ElementConditionMatcher');
5954 $elementConditionMatcher->setRecord($row);

5955 $elementConditionMatcher->setFlexformValueKey($ffValueKey);

5956 return $elementConditionMatcher->match($displayCond);

5957 }

| am not surprised about this error, cause of the called method "setRecord()" is not a method in
TYPO3\CMS\Backend\Form\ElementConditionMatcher.

Commenting out lines 5954 & 5955 has resolved the error and the media element is placed succesfully, but i am not sure whether this is the proper

way.
